<?php if (!defined('PmWiki')) exit();
/*
Copyright 2004, 2006 Nils Knappmeier
Copyright 2004 Patrick R. Michaud (pmichaud@pobox.com)
Copyright 2006, 2007, 2015, 2016, 2017 Hagan Fox

This file is addlink-cmsb.php; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.  
*/
SDV($AddlinkVersonString, "2017-01-30");

/***
* Settings
*/
## Link text
SDV($AddLinkText,"$[Add a link to ]".$pagename);
## Link title= (tooltip) text
SDV($AddLinkTitle,"$[AddLink Bookmarlket]");

/***
* Logic
*/
# Recipie info
SDV($RecipeInfo['AddLink']['Version'], $AddlinkVersonString);
# Page variable: {$AddlinkVerson}
SDV($FmtPV['$AddLinkVersion'],"'".$AddlinkVersonString."'");

# Add the (:addlink [PageName]:) markup and HandleAddLink actions.
Markup_e('addlink', 'inline', '/\\(:addlink\\s*(.*?):\\)/', 
  "Keep(CreateBookmarklet(\$pagename,\$m[1]))");
$HandleActions['addlink'] = 'HandleAddLink';

# Function to create the bookmarklet
function CreateBookmarklet($pagename, $linkpage) {
  global $AddLinkTitle, $AddLinkText;
  // Sniff browser to adapt selected-content portion
  $ua = $_SERVER['HTTP_USER_AGENT'];
  if (preg_match('!AppleWebKit!', $ua) // Safari
    || preg_match('!Konqueror!', $ua)
    || preg_match('!Opera!', $ua)) {
    $addlink_selected = "&amp;selected='+encodeURIComponent(window.getSelection())+'";
  } elseif (preg_match('!MSIE (6|7)!', $ua) //IE/Win
    || preg_match('!trident!i', $ua)
    && preg_match('!Win!', $ua)) {
    $addlink_selected = "&amp;selected='+encodeURIComponent(document.selection.createRange().text)+'"; 
  } elseif (preg_match('!gecko!i', $ua) // Mozilla, Firefox
    || preg_match('!icab!i', $ua)
    || preg_match('!powerpc!i', $ua)) {
    $addlink_selected = "&amp;selected='+encodeURIComponent(document.getSelection())+'";
  } else { $addlink_selected = ''; }
  if ($linkpage) $pagename = MakePageName($pagename, $linkpage);
  return FmtPageName("<a href=\"javascript:document.location.href='\$PageUrl?action=addlink&amp;url='+encodeURIComponent(document.location.href)+'$addlink_selected&amp;title='+encodeURIComponent(document.title),'bookmark'\" title=\"$AddLinkTitle\">$AddLinkText</a>", $pagename);
}

# Use the site's default edit page.
if ($action=='addlink') {
  $action = 'edit';
  $OldEditHandler = $HandleActions['edit'];
  $HandleActions['edit'] = 'HandleAddLink';
}

# Function to handle ?action=addlink (prepends the url to the page and
# then passes control to the edit function).
function HandleAddLink($pagename) {
  global  $OldEditHandler, $EnableAddLinkHeadingStyle, $EnableAddLinkToEnd;
  Lock(2);
  $page = RetrieveAuthPage($pagename, 'edit');
  if (!$page) Abort("?cannot edit $pagename");
  $text = get_magic_quotes_gpc() ? addslashes($page['text']) : $page['text'];
  if (@$_REQUEST['url']) {
    $_REQUEST['url'] = preg_replace('/\|/', '&#124;', $_REQUEST['url']); // Encode | to &#124;
    if (IsEnabled($EnableAddLinkHeadingStyle,0)) {
      if (IsEnabled($EnableAddLinkToEnd,0))
        $text .= "\n\n!! {$_REQUEST['title']}\n\n{$_REQUEST['selected']}\n\n{$_REQUEST['url']}\n";
      else $text = "!! {$_REQUEST['title']}\n\n{$_REQUEST['selected']}\n\n{$_REQUEST['url']}\n\n\n" . $text;
    } else {
      if (IsEnabled($EnableAddLinkToEnd,0))
        $text .= "\n\n:[[{$_REQUEST['url']}|{$_REQUEST['title']}]]: {$_REQUEST['selected']}\n";
      else $text = "\n:[[{$_REQUEST['url']}|{$_REQUEST['title']}]]: {$_REQUEST['selected']}\n\n" . $text;
    }
  }
  $action = 'edit';
  $_POST['text'] = $text;
  $OldEditHandler($pagename);
}

/* vim: set expandtab tabstop=2 shiftwidth=2: */
